//
//	Includes
//
#include	"MCF52233.h"
#include	"ProtoType.h"

//
//	main
//
void main(void)
{
UINT32 ip;	// IP address work
UINT8	*b, *m, *n, *h, *w;	// Pointers
UINT8	i;
INT8	soc;		// Socket
	h = (UINT8*)"whois.jprs.jp";	// JPRS server name
	m = (UINT8*)"[\223\157\230\136\216\322\226\274]";// Tourokusyamei
	n = (UINT8*)"[\221\147\220\104\226\274]";	// Soshikimei
	ip = GetHostByName(h);	// Get server IP address
	if(!ip)	// If not exists nor not resolved by DNS?
	{
		TermPuts((UINT8*)"Host?\r\n");	// Show error
		return;	// Exit this thread
	}
	b = MemoryAlloc(256);	// Allocate TCP/IP buffer
	w = MemoryAlloc(80);	// Allocate keyboard buffer
	for(;;)	// Repeat
	{
		StrCpy(w, (UINT8*)"Enter word=");	// Show prompt
		TermGets(w, 80, 11);	// Get one line (cursor pos is 11)
		BufCopy(w, w + 11, (UINT16)(StrLen(w) - 10));	// Delete prompt string
		if(!*w)		// If blank line?(Only enter key)
			break;	// Exit for loop
		soc = CreateSocket(1);	// Create TCP/IP socket
		if(Connect(soc,ip,80) < 0)	// Try to connect JPRS server
		{	// Error happen?
			TermPuts((UINT8*)"Connect?\r\n");	// Show error
			CloseSocket(soc);	// Destroy socket
			break;	// Exit loop
		}
		GetNetLine(0, 0, 0, 0);	// Init one line TCP/IP input
		StrCpy(b,(UINT8*)"GET /cgi-bin/whois_gw?key=");// Build HTTP request
		StrCat(b,w);	// Add search string
		StrCat(b,(UINT8*)" HTTP/1.1\r\nHost: ");	// Add host name headder
		StrCat(b,h);	// Add host name
		StrCat(b,(UINT8*)"\r\n\r\n");	// Add blank line (End of HTTP request)
		Write(soc, b, StrLen(b));	// Set HTTP request to JPRS server
		WaitWriteComplete(soc);		// Wait until send complete
		for(i = 0; i < 100; i++)	// Read HTTP response 100 lines
		{
			if(GetNetLine(soc,b,250,20) < 0)	// Some error happens?
				break;		// Exit inner for loop
			if(StrStr(b, m) || StrStr(b, n))	// Match reult string?
				break;		// Exit inner for loop
		}
		TermPuts(b);	// Show target line(result)
		TermPuts((UINT8*)"\r\n");	// Put CR+LF
		GetNetLine(0, 0, 0, 1);		// Clean up TCP/IP one line input
		CloseSocket(soc);	// Release socket work area
	}
	MemoryFree(w);	// Release keybooard buffer
	MemoryFree(b);	// Release TCP/IP buffer
	UserExit(1);		// Tell parent thread that this thread is over
}
