//
//	Prototypes
//

//
//	Interrupts macros
//
#define	DisableInterrupts			asm{move.w #0x2700,sr}
#define	EnableInterrupts			asm{move.w #0x2000,sr}	

//
//	High/Low macros
//
#define	LOWBYTE(X)	((X) & 255)
#define	HIGHBYTE(X)	((X) >> 8)

//
//	Callback function
//
typedef void(*CallbackFunc16)(UINT16);
typedef void(*CallbackFunc8)(UINT8);
typedef void(*CallbackFuncV)(void);

//
//	Constants
//
#define	SEEK_SET	0
#define	SEEK_CUR	1
#define	SEEK_END	2

//
//	Prototypes
//
#pragma pointers_in_D0

void *MemoryAlloc(UINT16 size);
void BufCopy(void *dst, void *src, UINT32 len);
void MemClear(void *ptr, UINT32 len);
void MemoryFree(void *);
void SystemSleep(void);
void Sleep(UINT16 time);
UINT8 CreateTimer(UINT8 mode, CallbackFunc8 func, UINT16 val, UINT8 timer, UINT8 stack);
UINT16	GetTimerCount(UINT8 timer);
UINT16 StrLen(UINT8 *x);
UINT8 *StrCat(UINT8 *x, UINT8 *y);
INT8 StrCmp(UINT8 *x, UINT8* y); 
UINT8 *StrCpy(UINT8 *x, UINT8 *y);
UINT8 *StrChr(UINT8 *x, UINT8 y);
UINT8 *StrStr(UINT8 *x, UINT8 *y);
void GetDigit(INT32 num, UINT8 *buf);
UINT32	GetCgiIPadrs(UINT8 *ptr);
UINT8 SciSense(void);
UINT8 SciGetc(void);
void SciPutc(UINT8);
void SciPuts(UINT8 *);
void SciGets(UINT8 *, UINT8);
void DefragFilesys(UINT16 key);
UINT8 CreateFile(UINT8 *filename);
UINT16 WriteFile(void *ptr, UINT16 size);
void CloseFile(UINT32 handle);
UINT8 DeleteFile(UINT8 *filename);
UINT8 MoveFile(UINT8 *filename, UINT8 *newfile);
UINT8	*FindFile(UINT8 init);
UINT32 GetFileSize(UINT8 *filename);
UINT32 OpenFile(UINT8 *filename);
UINT16 ReadFile(UINT32 handle, UINT8 *buf, UINT16 size);
UINT32 SeekFile(UINT32 fp, UINT32 pos, UINT8 org);
UINT32 GetFinalPos(void);
INT8 CreateSocket(UINT8 prot);
void CloseSocket(INT8 sochandle);
INT8 Connect(INT8 sochandle, UINT32 ip, UINT16 port);
INT8 Accept(INT8 sochandle, UINT16 timeout);
UINT8 Bind(INT8 sochandle, UINT16 port, UINT8 maxsoc);
INT16 Read(INT8 sochandle, UINT16 timeout);
INT16 Write(INT8 sochandle, UINT8 *buf, UINT16 len);
INT8 CheckWriteComplete(INT8 sochandle);
INT8 WaitWriteComplete(INT8 sochandle);
UINT8 *GetReceiveBuffer(INT8 sochandle, UINT8 release);
INT16 SendTo(INT8 sochandle, UINT32 ip, UINT16 port, UINT8 *buf, UINT16 len);
INT16 RecvFrom(INT8 sochandle, UINT16 timeout);
UINT32 GetSenderIP(INT8 sochandle);
UINT16 GetSenderPort(INT8 sochandle);
UINT32 GetHostByName(UINT8 *name);
INT16 GetDefMtu(INT8 sochandle, UINT16 mtu);
UINT8 NvmWrite(UINT32 *ad, UINT32 *src, UINT16 size);
UINT8 NvmErase(UINT32 *ad);
UINT16 GetNetLine(INT8 soc, UINT8 *recbuf, UINT8 limit, UINT8 func);
void TermPutc(UINT8 ch);
UINT8 TermGetc(void);
UINT8 TermSense(void);
void TermPuts(UINT8 *ptr);
void TermPutNum(INT32 num);
void TermPutIP(UINT32 ip);
void TermGets(UINT8 *ptr, UINT8 len, UINT8 echo);
UINT8	CreateThread(UINT32 adrs, UINT16 stacksize, UINT32 arg);
void WaitCriticalSession(UINT8 *flag);
void KillThread(UINT8 handle);
void InitAd(UINT8 port);
UINT16 GetAd(UINT8 ch);
void UserExit(UINT8 res);
